/*
 * SOL - Searchable Option List jQuery plugin
 * Version 2.0.2
 * https://pbauerochse.github.io/searchable-option-list/
 *
 * Copyright 2015, Patrick Bauerochse
 *
 * Licensed under the MIT license:
 * http://www.opensource.org/licenses/MIT
 *
 */

/*
 * Original based on SOL v2.0.2
 * Modified by Krystof Tulinger 2016, 2019
 * Minified with https://javascript-minifier.com/
 */
!function(t,e,i){"use strict";var s=function(t,e){this.$originalElement=t,this.options=e,this.metadata=this.$originalElement.data("sol-options")};s.defaults=(s.prototype={SOL_OPTION_FORMAT:{type:"option",value:void 0,selected:!1,disabled:!1,label:void 0,tooltip:void 0,cssClass:""},SOL_OPTIONGROUP_FORMAT:{type:"optiongroup",label:void 0,tooltip:void 0,disabled:!1,children:void 0},DATA_KEY:"sol-element",WINDOW_EVENTS_KEY:"sol-window-events",defaults:{data:void 0,name:void 0,texts:{noItemsAvailable:"No entries found",selectAll:"Select all",selectNone:"Select none",quickDelete:"&times;",searchplaceholder:"Click here to search",loadingData:"Still loading data...",itemsSelected:"{$a} more items selected"},events:{onInitialized:void 0,onRendered:void 0,onOpen:void 0,onClose:void 0,onChange:void 0,onScroll:function(){var t=this.$input.offset().top-this.config.scrollTarget.scrollTop()+this.$input.outerHeight(!1),e=this.$selectionContainer.outerHeight(!1),s=t+e,n=this.config.displayContainerAboveInput||i.documentElement.clientHeight-this.config.scrollTarget.scrollTop()<s,o=this.$innerContainer.outerWidth(!1)-parseInt(this.$selectionContainer.css("border-left-width"),10)-parseInt(this.$selectionContainer.css("border-right-width"),10);if(n?(t=this.$input.offset().top-e-this.config.scrollTarget.scrollTop()+parseInt(this.$selectionContainer.css("border-bottom-width"),10),this.$container.removeClass("sol-selection-bottom").addClass("sol-selection-top")):this.$container.removeClass("sol-selection-top").addClass("sol-selection-bottom"),"block"!==this.$innerContainer.css("display"))o*=1.2;else{var l=n?"border-bottom-right-radius":"border-top-right-radius";this.$selectionContainer.css(l,"initial"),this.$actionButtons&&this.$actionButtons.css(l,"initial")}this.$selectionContainer.css("top",Math.floor(t)).css("left",Math.floor(this.$container.offset().left)).css("width",o),this.config.displayContainerAboveInput=n}},selectAllMaxItemsThreshold:30,showSelectAll:function(){return this.config.multiple&&this.config.selectAllMaxItemsThreshold&&this.items&&this.items.length<=this.config.selectAllMaxItemsThreshold},useBracketParameters:!1,multiple:void 0,resultsContainer:void 0,closeOnClick:!1,showSelectionBelowList:!1,allowNullSelection:!1,scrollTarget:void 0,maxHeight:void 0,converter:void 0,asyncBatchSize:300,searchTimeout:300,maxShow:0},init:function(){this.config=t.extend(!0,{},this.defaults,this.options,this.metadata);var i=this._getNameAttribute(),s=this;if(i)return"function"!=typeof String.prototype.trim&&(String.prototype.trim=function(){return this.replace(/^\s+|\s+$/g,"")}),this.config.multiple=this.config.multiple||this.$originalElement.attr("multiple"),this.config.scrollTarget||(this.config.scrollTarget=t(e)),this._registerWindowEventsIfNecessary(),this._initializeUiElements(),this._initializeInputEvents(),setTimeout(function(){s._initializeData(),s.$originalElement.data(s.DATA_KEY,s).removeAttr("name").data("sol-name",i)},0),this.$originalElement.hide(),this.$container.css("visibility","initial").show(),this;this._showErrorLabel("name attribute is required")},_getNameAttribute:function(){return this.config.name||this.$originalElement.data("sol-name")||this.$originalElement.attr("name")},_showErrorLabel:function(e){var i=t('<div style="color: red; font-weight: bold;" />').html(e);this.$container?this.$container.append(i):i.insertAfter(this.$originalElement)},_registerWindowEventsIfNecessary:function(){e[this.WINDOW_EVENTS_KEY]||(t(i).click(function(e){var i,n=t(e.target),o=n.closest(".sol-selection-container"),l=n.closest(".sol-inner-container");l.length?i=l.first().parent(".sol-container"):o.length&&(i=o.first().parent(".sol-container")),t(".sol-active").not(i).each(function(e,i){t(i).data(s.prototype.DATA_KEY).close()})}),e[this.WINDOW_EVENTS_KEY]=!0)},_initializeUiElements:function(){var s=this;this.internalScrollWrapper=function(){t.isFunction(s.config.events.onScroll)&&s.config.events.onScroll.call(s)},this.$input=t('<input type="text"/>').attr("placeholder",this.config.texts.searchplaceholder),this.$noResultsItem=t('<div class="sol-no-results"/>').html(this.config.texts.noItemsAvailable).hide(),this.$loadingData=t('<div class="sol-loading-data"/>').html(this.config.texts.loadingData),this.$xItemsSelected=t('<div class="sol-results-count"/>'),this.$caret=t('<div class="sol-caret-container"><b class="sol-caret"/></div>').click(function(t){return s.toggle(),t.preventDefault(),!1});var n=t('<div class="sol-input-container"/>').append(this.$input);this.$innerContainer=t('<div class="sol-inner-container"/>').append(n).append(this.$caret),this.$selection=t('<div class="sol-selection"/>'),this.$selectionContainer=t('<div class="sol-selection-container"/>').append(this.$noResultsItem).append(this.$loadingData).append(this.$selection),this.$container=t('<div class="sol-container"/>').hide().keydown(function(n){if(13==n.keyCode){var o="";if(t("#sbox #qtbl input[type='text']").each(function(){o+=t.trim(t(this).val())}),13==n.keyCode&&""===o){if(""!==s.$input.val())return e.location=i.xrefPath+"/"+s.$input.val(),!1;var l=t(".keyboard-selection").first().find(".sol-checkbox");return l.length&&l.data("sol-item")&&l.data("sol-item").label?(e.location=i.xrefPath+"/"+l.data("sol-item").label,!1):!(!(l=t(".sol-selected-display-item").first()).length||!l.data("label"))&&(e.location=i.xrefPath+"/"+l.data("label"),!1)}return!0}}).data(this.DATA_KEY,this).append(this.$selectionContainer).append(this.$innerContainer).insertBefore(this.$originalElement),this.$showSelectionContainer=t('<div class="sol-current-selection"/>');var o=this.config.resultsContainer||this.$innerContainer;this.config.resultsContainer?this.$showSelectionContainer.appendTo(o):this.config.showSelectionBelowList?this.$showSelectionContainer.insertAfter(o):this.$showSelectionContainer.insertBefore(o),this.config.maxHeight&&this.$selection.css("max-height",this.config.maxHeight);var l=this.$originalElement.attr("class"),a=this.$originalElement.attr("style"),r=[],c=[];if(l&&l.length>0){r=l.split(/\s+/);for(var h=0;h<r.length;h++)this.$container.addClass(r[h])}if(a&&a.length>0){c=a.split(/\;/);for(h=0;h<c.length;h++){var d=c[h].split(/\s*\:\s*/g);2===d.length&&(d[0].toLowerCase().indexOf("height")>=0?this.$innerContainer.css(d[0].trim(),d[1].trim()):this.$container.css(d[0].trim(),d[1].trim()))}}"block"!==this.$originalElement.css("display")&&this.$container.css("width",this._getActualCssPropertyValue(this.$originalElement,"width")),t.isFunction(this.config.events.onRendered)&&this.config.events.onRendered.call(this,this)},_getActualCssPropertyValue:function(t,s){var n=t.get(0),o=t.css("display");return t.css("display","none"),n.currentStyle?n.currentStyle[s]:e.getComputedStyle?i.defaultView.getComputedStyle(n,null).getPropertyValue(s):(t.css("display",o),t.css(s))},_initializeInputEvents:function(){var e=this,i=this.$input.parents("form").first();if(i&&1===i.length&&!i.data(this.WINDOW_EVENTS_KEY)){var s=function(){var s=[];i.find(".sol-option input").each(function(e,i){var n=t(i),o=n.data("sol-item").selected;n.prop("checked")!==o&&(n.prop("checked",o).trigger("sol-change",!0),s.push(n))}),s.length>0&&t.isFunction(e.config.events.onChange)&&e.config.events.onChange.call(e,e,s)};i.on("reset",function(t){s.call(e),setTimeout(function(){s.call(e)},100)}),i.data(this.WINDOW_EVENTS_KEY,!0)}this.$input.focus(function(){e.open()}).on("propertychange input",function(i){var s=!0;"propertychange"==i.type&&(s="value"==i.originalEvent.propertyName.toLowerCase()),s&&(t(this).data("timeout")&&clearTimeout(t(this).data("timeout")),t(this).data("timeout",setTimeout(function(){e._applySearchTermFilter()},e.config.searchTimeout)))}),this.$container.on("keydown",function(i){var s=i.keyCode;if(!e.$noResultsItem.is(":visible")){var n,o,l=!1,a=e.$selection.find(".sol-option:visible");if(40===s||38===s){e._setKeyBoardNavigationMode(!0),(n=e.$selection.find(".sol-option.keyboard-selection")).find("input[type='checkbox']").blur(),o=38===s?-1:1;var r=a.index(n)+o;r<0?r=a.length-1:r>=a.length&&(r=0),n.removeClass("keyboard-selection"),t(a[r]).addClass("keyboard-selection").find("input[type='checkbox']").focus(),l=!0}else!0===e.keyboardNavigationMode&&32===s&&((n=e.$selection.find(".sol-option.keyboard-selection input")).trigger("change"),l=!0);if(l)return i.preventDefault(),!1}}).on("keyup",function(t){var i=t.keyCode;if(27===i)!0===e.keyboardNavigationMode?e._setKeyBoardNavigationMode(!1):""===e.$input.val()?(e.$caret.trigger("click"),e.$input.trigger("blur")):e.$input.val("").trigger("input");else if(16===i||17===i||18===i||20===i)return})},_setKeyBoardNavigationMode:function(t){t?(this.keyboardNavigationMode=!0,this.$selection.addClass("sol-keyboard-navigation")):(this.keyboardNavigationMode=!1,this.$selection.find(".sol-option.keyboard-selection"),this.$selection.removeClass("sol-keyboard-navigation"),this.$selectionContainer.find(".sol-option.keyboard-selection").removeClass("keyboard-selection"),this.$selection.scrollTop(0))},_applySearchTermFilter:function(){if(this.items&&0!==this.items.length){var e=(this.$input.val()||"").toLowerCase();this.$selectionContainer.find(".sol-filtered-search").removeClass("sol-filtered-search"),this._setNoResultsItemVisible(!1),e.trim().length>0&&this._findTerms(this.items,e),t.isFunction(this.config.events.onScroll)&&this.config.events.onScroll.call(this)}},_findTerms:function(e,i){if(e&&t.isArray(e)&&0!==e.length){var s=e.length;this._setKeyBoardNavigationMode(!1);for(var n=0;n<e.length;n++){var o=e[n];if("option"===o.type){var l=o.displayElement;-1===(o.label+" "+o.tooltip).trim().toLowerCase().indexOf(i)&&(l.addClass("sol-filtered-search"),s--)}else{for(var a=o.children.length,r=0;r<o.children.length;r++){var c=o.children[r];if("option"===c.type){l=c.displayElement;-1===(c.label+" "+c.tooltip).trim().toLowerCase().indexOf(i)&&(l.addClass("sol-filtered-search"),a--)}}0===a&&(o.displayElement.addClass("sol-filtered-search"),s--)}}this._setNoResultsItemVisible(0===s)}},_initializeData:function(){this.config.data?t.isFunction(this.config.data)?this.items=this._fetchDataFromFunction(this.config.data):t.isArray(this.config.data)?this.items=this._fetchDataFromArray(this.config.data):"string"==typeof this.config.data?this._loadItemsFromUrl(this.config.data):this._showErrorLabel("Unknown data type"):this.items=this._detectDataFromOriginalElement(),this.items&&this._processDataItems(this.items)},_detectDataFromOriginalElement:function(){if("select"===this.$originalElement.prop("tagName").toLowerCase()){var e=this,i=[];return t.each(this.$originalElement.children(),function(s,n){var o,l=t(n),a=l.prop("tagName").toLowerCase();"option"===a?(o=e._processSelectOption(l))&&i.push(o):"optgroup"===a?(o=e._processSelectOptgroup(l))&&i.push(o):e._showErrorLabel("Invalid element found in select: "+a+". Only option and optgroup are allowed")}),this._invokeConverterIfNecessary(i)}if(this.$originalElement.data("sol-data")){var s=this.$originalElement.data("sol-data");return this._invokeConverterIfNecessary(s)}this._showErrorLabel('Could not determine data from original element. Must be a select or data must be provided as data-sol-data="" attribute')},_processSelectOption:function(e){return t.extend({},this.SOL_OPTION_FORMAT,{value:e.val(),selected:e.prop("selected"),disabled:e.prop("disabled"),cssClass:e.attr("class"),label:e.html(),tooltip:e.attr("title"),element:e})},_processSelectOptgroup:function(e){var i=this,s=t.extend({},this.SOL_OPTIONGROUP_FORMAT,{label:e.attr("label"),tooltip:e.attr("title"),disabled:e.prop("disabled"),children:[]}),n=e.children("option");return t.each(n,function(e,n){var o=t(n),l=i._processSelectOption(o);s.disabled&&(l.disabled=!0),s.children.push(l)}),s},_fetchDataFromFunction:function(t){return this._invokeConverterIfNecessary(t(this))},_fetchDataFromArray:function(t){return this._invokeConverterIfNecessary(t)},_loadItemsFromUrl:function(e){var i=this;t.ajax(e,{success:function(t){i.items=i._invokeConverterIfNecessary(t),i.items&&i._processDataItems(i.items)},error:function(t,s,n){i._showErrorLabel("Error loading from url "+e+": "+n)},dataType:"json"})},_invokeConverterIfNecessary:function(e){return t.isFunction(this.config.converter)?this.config.converter.call(this,this,e):e},_processDataItems:function(e){if(e){if(0===e.length)return this._setNoResultsItemVisible(!0),void this.$loadingData.remove();var i=this,s=0,n=function(){for(var o,l=0;l++<i.config.asyncBatchSize&&s<e.length;)if((o=e[s++]).type===i.SOL_OPTION_FORMAT.type)i._renderOption(o);else{if(o.type!==i.SOL_OPTIONGROUP_FORMAT.type)return void i._showErrorLabel("Invalid item type found "+o.type);i._renderOptiongroup(o)}s>=e.length?function(){this.$loadingData.remove(),this._initializeSelectAll(),t.isFunction(this.config.events.onInitialized)&&this.config.events.onInitialized.call(this,this,e)}.call(i):setTimeout(n,0)};n.call(this)}else this._showErrorLabel("Data items not present. Maybe the converter did not return any values")},_renderOption:function(s,n){var o,l,a,r=this,c=n||this.$selection,h=t('<div class="sol-label-text"/>').html(0===s.label.trim().length?"&nbsp;":s.label).addClass(s.cssClass),d=this._getNameAttribute(),p=t(s.element).data("messages");p&&p.length&&h.append(t("<span>").addClass("pull-right important-note important-note-rounded").data("messages",p).attr("data-messages","").text("!")),this.config.multiple?(o=t('<input type="checkbox" class="sol-checkbox"/>'),this.config.useBracketParameters&&(d+="[]")):o=t('<input type="radio" class="sol-radio"/>').on("change",function(){r.$selectionContainer.find('input[type="radio"][name="'+d+'"]').not(t(this)).trigger("sol-deselect")}).on("sol-deselect",function(){r._removeSelectionDisplayItem(t(this))}),o.on("change",function(e,i){t(this).trigger("sol-change",i)}).on("sol-change",function(e,i){var s=t(this).closest(".sol-option");r._setKeyBoardNavigationMode(!0),r.$selection.find(".sol-option.keyboard-selection").removeClass("keyboard-selection"),s.addClass("keyboard-selection"),r._selectionChange(t(this),i)}).data("sol-item",s).prop("checked",s.selected).prop("disabled",s.disabled).attr("name",d).val(s.value),l=t('<label class="sol-label"/>').attr("title",s.tooltip).append(o).append(h),a=t('<div class="sol-option"/>').dblclick(function(s){var n=t(this).find(".sol-checkbox");n.length&&n.data("sol-item")&&n.data("sol-item").label&&(e.location=i.xrefPath+"/"+t(this).find(".sol-checkbox").data("sol-item").label)}).append(l),o.data("messages-available",p&&p.length),s.displayElement=a,c.append(a),s.selected&&this._addSelectionDisplayItem(o)},_renderOptiongroup:function(e){var i=this,s=t('<div class="sol-optiongroup-label"/>').attr("title",e.tooltip).html(e.label),n=t('<input class="sol-checkbox" style="display: none" type="checkbox" name="group" value="'+e.label+'"/>'),o=t('<div class="sol-optiongroup"/>').append(s).append(n);e.disabled&&o.addClass("disabled"),s.click(function(e){i.config.multiple&&(e.ctrlKey||i.deselectAll(),i.selectAll(t(this).text()),i.$selection.scrollTop(i.$selection.scrollTop()+t(this).position().top))}),this.$selection.append(o),t.isArray(e.children)&&t.each(e.children,function(t,e){i._renderOption(e,o)}),e.displayElement=o},_initializeSelectAll:function(){if(!0===this.config.showSelectAll||t.isFunction(this.config.showSelectAll)&&this.config.showSelectAll.call(this)){var e=this,i=t('<a href="#" class="sol-deselect-all"/>').html(this.config.texts.selectNone).click(function(t){return e.deselectAll(),t.preventDefault(),!1}),s=t('<a href="#" class="sol-select-all"/>').html(this.config.texts.selectAll).click(function(t){return e.selectAll(),t.preventDefault(),!1});this.$actionButtons=t('<div class="sol-action-buttons"/>').append(s).append(i).append('<div class="sol-clearfix"/>'),this.$selectionContainer.prepend(this.$actionButtons)}},_selectionChange:function(e,i){if(this.$originalElement&&"select"===this.$originalElement.prop("tagName").toLowerCase()){var s=this;this.$originalElement.find("option").each(function(i,n){var o=t(n);if(o.val()===e.val())return o.prop("selected",e.prop("checked")),void s.$originalElement.trigger("change")})}e.prop("checked")?this._addSelectionDisplayItem(e):this._removeSelectionDisplayItem(e),this.config.multiple?this.config.scrollTarget.trigger("scroll"):this.close(),!i&&t.isFunction(this.config.events.onChange)&&this.config.events.onChange.call(this,this,e)},_addSelectionDisplayItem:function(e){var i,s=e.data("sol-item"),n=s.displaySelectionItem;if(!n){var o=this.$showSelectionContainer.children(".sol-selected-display-item"),l=s.label;if(e.data("messages-available")&&(l+=' <span class="important-note important-note-rounded" ',l+='title="Some message is important in this project.',l+=' Find more info in the project list.">!</span>'),i=t('<span class="sol-selected-display-item-text" />').html(l),n=t('<div class="sol-selected-display-item"/>').append(i).attr("title",s.tooltip).data("label",s.label).appendTo(this.$showSelectionContainer).dblclick(function(){e.dblclick()}),!this.config.multiple&&!this.config.allowNullSelection||e.prop("disabled")||t('<span class="sol-quick-delete"/>').html(this.config.texts.quickDelete).click(function(){e.prop("checked",!1).trigger("change"),isOnSearchPage()&&t("#sbox").submit()}).prependTo(n),0!=this.config.maxShow&&o.length+1>this.config.maxShow){var a=this.config.texts.itemsSelected.replace("{$a}",o.length+1-this.config.maxShow);this.$xItemsSelected.html('<div class="sol-selected-display-item-text">'+a+"<div>"),this.$showSelectionContainer.append(this.$xItemsSelected),this.$xItemsSelected.show(),n.hide()}s.displaySelectionItem=n}},_removeSelectionDisplayItem:function(t){var e=t.data("sol-item"),i=e.displaySelectionItem;if(i){var s=this.$showSelectionContainer.children(".sol-selected-display-item");if(0!=this.config.maxShow&&s.length-1>this.config.maxShow){var n=this.config.texts.itemsSelected.replace("{$a}",s.length-1-this.config.maxShow);this.$xItemsSelected.html('<div class="sol-selected-display-item-text">'+n+"<div>"),this.$showSelectionContainer.append(this.$xItemsSelected),this.$xItemsSelected.show()}else this.$xItemsSelected.hide();i.is(":visible")&&i.siblings(".sol-selected-display-item").not(":visible").not(this.$xItemsSelected).first().show(),i.remove(),e.displaySelectionItem=void 0}},_setNoResultsItemVisible:function(t){t?(this.$noResultsItem.show(),this.$selection.hide(),this.$actionButtons&&this.$actionButtons.hide()):(this.$noResultsItem.hide(),this.$selection.show(),this.$actionButtons&&this.$actionButtons.show())},isOpen:function(){return this.$container.hasClass("sol-active")},isClosed:function(){return!this.isOpen()},toggle:function(){this.isOpen()?this.close():this.open()},open:function(){this.isClosed()&&(this.$container.addClass("sol-active"),this.config.scrollTarget.bind("scroll",this.internalScrollWrapper).trigger("scroll"),t(e).on("resize",this.internalScrollWrapper),t.isFunction(this.config.events.onOpen)&&this.config.events.onOpen.call(this,this))},close:function(){this.isOpen()&&(this._setKeyBoardNavigationMode(!1),this.$container.removeClass("sol-active"),this.config.scrollTarget.unbind("scroll",this.internalScrollWrapper),t(e).off("resize"),this.$input.val(""),this._applySearchTermFilter(),this.config.displayContainerAboveInput=void 0,t.isFunction(this.config.events.onClose)&&this.config.events.onClose.call(this,this))},selectAll:function(e){if(this.config.multiple){var i=e?this.$selectionContainer.find(".sol-optiongroup-label").filter(function(){return t(this).text()===e}).closest(".sol-optiongroup"):this.$selectionContainer;i=i.find('input[type="checkbox"]:not([disabled], :checked)').prop("checked",!0).trigger("change",!0),this.config.closeOnClick&&this.close(),t.isFunction(this.config.events.onChange)&&this.config.events.onChange.call(this,this,i)}},invert:function(){if(this.config.multiple){var e=this.$selectionContainer.find('input[type="checkbox"][name=project]:not([disabled], :checked)'),i=this.$selectionContainer.find('input[type="checkbox"][name=project]').filter("[disabled], :checked");i.prop("checked",!1).trigger("change",!0),e.prop("checked",!0).trigger("change",!0),this.config.closeOnClick&&this.close(),t.isFunction(this.config.events.onChange)&&this.config.events.onChange.call(this,this,i.add(e))}},deselectAll:function(e){if(this.config.multiple){var i=e?this.$selectionContainer.find(".sol-optiongroup-label").filter(function(){return t(this).text()===e}).closest(".sol-optiongroup"):this.$selectionContainer;i=i.find('.sol-option input[type="checkbox"]:not([disabled]):checked').prop("checked",!1).trigger("change",!0),this.options.closeOnClick&&this.close(),t.isFunction(this.config.events.onChange)&&this.config.events.onChange.call(this,this,i)}},getSelection:function(){return this.$selection.find("input:checked")}}).defaults,e.SearchableOptionList=s,t.fn.searchableOptionList=function(e){var i=[];return this.each(function(){var n=t(this),o=n.data(s.prototype.DATA_KEY);if(o)i.push(o);else{var l=new s(n,e);i.push(l),setTimeout(function(){l.init()},0)}}),1===i.length?i[0]:i}}(jQuery,window,document);
